App/Model/UserModel.php
<?php
	
	/**
	 * --------------------------------------------------------------------------
	 *   @Copyright : License MIT 2017
	 *
	 *   @Author : Alexandre Caillot
	 *   @WebSite : https://www.shiros.fr
	 *
	 *   @File : UserModel.php
	 *   @Created_at : 09/12/2017
	 *   @Update_at : 09/12/2017
	 * --------------------------------------------------------------------------
	 */

	namespace App\Model;
	
	use App\Core\AppModel;
	
	/**
	 * Représente une ligne de la base de données
	 * Herite de AppModel
	 */	
	class UserModel extends AppModel
	{
		public function getSerialId() { return substr($this->idNumber,1); }
		
		public function getDateFormat()
		{
			$date = new \DateTime();
			$date->setTimestamp($this->date);
			return $date->format($this->ConfigModule->get('User.Date.Format'));
		}
	}	
?>

App/Controller/AppController.php
<?php
	
	/**
	 * --------------------------------------------------------------------------
	 *   @Copyright : License MIT 2017
	 *
	 *   @Author : Alexandre Caillot
	 *   @WebSite : https://www.shiros.fr
	 *
	 *   @File : AppController.php
	 *   @Created_at : 05/12/2017
	 *   @Update_at : 05/12/2017
	 * --------------------------------------------------------------------------
	 */

	namespace App\Controller;

	use \App;
	
	use ShirOSBundle\Utils\Url\Url;
	use ShirOSBundle\Controller\Controller;
	use ShirOSBundle\Utils\Exception\RouteException;

	class AppController extends Controller
	{
		/**
		 * AppController constructor.
		 */
		public function __construct()
		{
			parent::__construct();

			$this->ApplicationModule = App::getInstance();
			$this->UrlModule = new Url($this->ConfigModule->get('Server.Homepage'));
			$this->SessionModule->navSet();
		}
	}
?>

App/Controller/HomeController.php
<?php
	
	/**
	 * --------------------------------------------------------------------------
	 *   @Copyright : License MIT 2017
	 *
	 *   @Author : Alexandre Caillot
	 *   @WebSite : https://www.shiros.fr
	 *
	 *   @File : HomeController.php
	 *   @Created_at : 05/12/2017
	 *   @Update_at : 05/12/2017
	 * --------------------------------------------------------------------------
	 */
		
	namespace App\Controller;
	
	use App\Core\Services\HomeService;
	use App\Core\Utils\Authentication\AppAuthentication;
	use App\Core\Utils\Validation\HomeValidation;
	use ShirOSBundle\View\HTML\ShirOSForm;
	
	class HomeController extends AppController
	{
		/**
		 * Instance de la classe de validation de formulaire
		 * @var HomeService
		 */
		protected $HomeService;
		/**
		 * Instance de la Classe de gestion de l'authentification
		 * @var AppAuthentication
		 */
		protected $AuthModule;
		
		/**
		 * Instance de la classe de validation de formulaire
		 * @var HomeValidation
		 */
		protected $ValidationModule;
		
		
		/**
		 * HomeController constructor.
		 */
		public function __construct()
		{
			parent::__construct();
			$this->HomeService = new HomeService();
			$this->AuthModule = new AppAuthentication();
			$this->ValidationModule = new HomeValidation();
		}
		
		
		/* ------------------------ Route ------------------------ */
		
		/**
		 * Homepage
		 * @throws \ShirOSBundle\Utils\Exception\ValidationException
		 */
		public function index()
		{
			$errors = [];
			$valid = true;
			$logged = false;
			$user = NULL;
				
            if($this->RequestModule->isPostRequest()) {
                $post = $this->RequestModule->getPostRequest();
                
                $this->ValidationModule->validateForm($post);
	            $valid = $this->ValidationModule->isValid();
                
                if ($valid) {
                    $values = $this->ValidationModule->getValues();
                    $user = $this->HomeService->createUser($values);
                    $logged = $this->AuthModule->loggedAdmin();
                } else {
                	$errors = $this->ValidationModule->getErrors();
                }
            }

			$elements = [
				'Items 1',
				'Items 2',
				'Items 3',
				'Items 4',
				'Items 5',
				'Items 6',
				'Items 7',
				'Items 8',
				'Items 9',
				'Items 10',
			];
            
            $form = new ShirOSForm($this->RequestModule->getPostRequest());
			
			$var = compact('elements', 'form', 'user', 'logged', 'valid', 'errors');
			$this->render('Home.index', $var);
		}
	}
?>

App/Controller/Security/SecurityController.php
<?php
	
	/**
	 * --------------------------------------------------------------------------
	 *   @Copyright : License MIT 2017
	 *
	 *   @Author : Alexandre Caillot
	 *   @WebSite : https://www.shiros.fr
	 *
	 *   @File : SecurityController.php
	 *   @Created_at : 05/12/2017
	 *   @Update_at : 05/12/2017
	 * --------------------------------------------------------------------------
	 */
	
	namespace App\Controller\Security;

	use App\Controller\AppController;
	use App\Core\Utils\Authentication\AppAuthentication;
	
	class SecurityController extends AppController
	{
		/**
		 * Instance de la Classe de gestion de l'authentification
		 * @var AppAuthentication
		 */
		protected $AuthModule;
		
		/**
		 * SecurityController constructor.
		 */
		public function __construct()
		{
			parent::__construct();
			$this->AuthModule = new AppAuthentication();
		}
		
		/* ------------------------ Route ------------------------ */
		
		/**
		 * Homepage
		 */
		public function secure()
		{
			$this->render('Security.security');
		}
		
		/**
		 * Logout
		 */
		public function logout()
		{
			$this->AuthModule->logout();
			header('Location: ' . $this->UrlModule->getUrl());
		}
	}
	?>

App/View/Home/index.php
<?php
	use ShirOSBundle\Config;
	use ShirOSBundle\Utils\Url\Url;
	use ShirOSBundle\View\HTML\ShirOSForm;
	use ShirOSBundle\Utils\Session\Session;
	
	/** @var Url $UrlModule */
	/** @var ShirOSForm $form */
	/** @var Config $ConfigModule */
	/** @var Session $SessionModule */
?>

<section class="padding-40">

    <article class="post">
        <div class="post-header">Demo</div>
        <div class="post-content">
            <h2 class="text-center">Welcome to the Demo of ShirOS Framework</h2>
    
            <legend>Elements Lists :</legend>
            
            
            <div class="overflow">
                <table>
                    <thead>
                        <tr id="header">
                            <th id="LastName">Name</th>
                        </tr>
                    </thead>
    
                    <tbody class="divMaxHeight-200PX">
                        <?php foreach ($elements as $element): ?>
                            <tr>
                                <td><?= $element; ?></td>
                            </tr>
                        <?php endforeach; ?>
                    </tbody>
                </table>
            </div>
    </article>
    
    <article class="post">
        <div class="post-header">Test Security</div>
        <div class="post-content">
            <div class="divWidth-80 div-center">
                
                <?php if($logged): ?>
                    <div class="alert alert-success"><a>You are Logged !</a></div>
    
                    <legend>User Informations : </legend>
    
                    <div class="marginTop-20 marginLeft-20">
                        <p class="margin-5"><span class="text-bold">Id :</span> <span class="text-italic"><?= $SessionModule->authValueFor($ConfigModule->get('ShirOS.Session.Id')); ?></span></p>
                        <p class="margin-5"><span class="text-bold">Username :</span> <span class="text-italic"><?= $user->username; ?></span></p>
                        <p class="margin-5"><span class="text-bold">Email :</span> <span class="text-italic"><?= $user->email; ?></span></p>
                        <p class="margin-5"><span class="text-bold">Date :</span> <span class="text-italic"><?= $user->dateFormat; ?></span></p>
                    </div>
                
                <?php else: ?>
                    <form method="POST">
    
                        <legend>Connexion : </legend>
    
                        <!-- USERNAME -->
	
                            <?php if(isset($errors[$ConfigModule->get('Fields.Name.Username')])) : ?>
                                <?= $form->field($ConfigModule->get('Fields.Name.Username'), 'Username', NULL, [], true); ?>
                            <?php else: ?>
                                <?= $form->field($ConfigModule->get('Fields.Name.Username'), 'Username'); ?>
                            <?php endif; ?>
    
                        <!-- EMAIL -->
	
                            <?php if(isset($errors[$ConfigModule->get('Fields.Name.Email')])) : ?>
                                <?= $form->field($ConfigModule->get('Fields.Name.Email'), 'Email Address', NULL, [], true); ?>
                                <?php if(!empty($errors[$ConfigModule->get('Fields.Name.Email')])): ?>
                                    <div class="alert alert-danger-revert text-size-14"><?= $errors[$ConfigModule->get('Fields.Name.Email')] ?></div>
                                <?php endif; ?>
                            <?php else: ?>
                                <?= $form->field($ConfigModule->get('Fields.Name.Email'), 'Email Address'); ?>
                            <?php endif; ?>
    
                        <!-- TEST -->
	
	                        <?= $form->field($ConfigModule->get('Fields.Name.Test'), 'Test Field'); ?>
	
	                    <?= $form->submit('Test !', NULL, [ShirOSForm::OPTIONS_SURROUND => 'divInline-center marginTop-20']); ?>
                    </form>
                <?php endif; ?>
    
                <legend>Try to go on the Security URL :</legend>
                
                    <div class="text-center">
                        <a href="<?= $UrlModule->getUrl('Security'); ?>" class="btn btn-danger">Security Page</a>
                    </div>
            </div>
    </article>
    
    <?php if(!$valid): ?>
        <div class="alert alert-danger marginTop-20 marginBottom-20"><a>Nous avons rencontré des difficultés</a></div>
    <?php endif; ?>
    
</section>

App/View/Security/security.php
<?php
	use ShirOSBundle\Utils\Url\Url;
	
	/** @var Url $UrlModule */
?>

<section class="padding-40">

    <article class="post">
        <div class="post-header">Congratulation !</div>
        <div class="post-content">
            <h2 class="text-center">You are on a Security Page</h2>

            <legend>Loggout :</legend>
                <div class="text-center">
                    <a href="<?= $UrlModule->getUrl('Logout'); ?>" class="btn btn-danger">Logout</a>
                </div>
    </article>

</section>

App/View/Templates/Footer.php
	  

	</div>
	<!-- Corps de Site -->
	
  </body>
</html>

App/View/Templates/Header.php
<!DOCTYPE html>
<html lang="fr">

<!-- Debut En-tête -->
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1">
        
        <?php if (!empty($MetaDataModule->getTitle())): ?>
            <meta name="title" content="<?= $MetaDataModule->getTitle(); ?>">
        <?php endif ?>
        
        <?php if (!empty($MetaDataModule->getDescription())): ?>
            <meta name="description" content="<?= $MetaDataModule->getDescription(); ?>">
        <?php endif ?>
        
        <?php if (!empty($MetaDataModule->getKeywords())): ?>
            <meta name="keywords" content="<?= $MetaDataModule->getKeywords(); ?>">
        <?php endif ?>
    
        <meta name="author" content="<?= $ConfigModule->get("Server.Author"); ?>">
        <meta name="generator" content="<?= $ConfigModule->get("Server.Author"); ?>">
        
        <?php if (empty($MetaDataModule->getTitle())): ?>
            <title><?= $ConfigModule->get("Server.Name"); ?></title>
        <?php else: ?>
            <title><?= $MetaDataModule->getTitle() . ' - ' . $ConfigModule->get("Server.Name"); ?></title>
        <?php endif ?>
    
        <!-- Css -->
            <?= App::getInstance()->getCss("public/Css/"); ?>
    </head>
<!-- END En-tête -->
    
    <body>
        <header id="Header">
            <div id="Menu">
                <nav>
                    <a href="<?= $UrlModule->getUrl() ?>">ShirOS Back Office</a>
                </nav>
            </div>
        </header>
        
        <!-- Corps de Site -->
        <div id="Page" class="noPadding">